'''
RASTER2GCODE
raster laser gcode genrator
copyright Cedric Doutriaux 2014
Licence creative commons cc-by-sa

'''


from PIL import Image
import string 

#########################################################parameters
fichier="voiture_ping_raster_revert.png"#inputfile (gray colormode)
laserwidth=0.2#largeur du trait du laser
dpi=300
speed=7200
minPower=0.0#minimum power (for white)
maxPower=0.2#maximum power (for black)
Zofset=9# for focal adjustement



im = Image.open(fichier) 
name=string.split(fichier,".") 
print name[0]


data = list(im.getdata())
print("l'image est chargee")
#print im.format, im.size, im.mode

width=round(float(im.size[0])/dpi*25.4,3)
height=round(float(im.size[1])/dpi*25.4,3)
print("taille (mm):")
print width,height




nlines=int(height/laserwidth)
#nlines=10
nb=im.convert("L")
raster = nb.resize((im.size[0], nlines), Image.ANTIALIAS) 
#raster.show()






print(nlines)


gcode="G92 X0 Y0 Z0\n"
gcode +="G0 Z"+str(Zofset)+"\n"
gcode += "M10\n"

power=-1
gcodelines=0
direction=1

for y in range(nlines-1):
	
	if direction==1:
	  startx=0
	else:
	  startx=im.size[0]
	
	gcode +="G0 Y"+str(y*laserwidth)+" X"+str(round(float(startx)/dpi*25.4,3))+"\n"
	
	for x in range(im.size[0]):
	
		#newpower=round(raster.getpixel((x,y))/255,3)
		if direction==1:
		  curx=x
		else:
		  curx=im.size[0]-x-1 
		
		
		newpower=minPower+((maxPower-minPower)*(1-round(float(raster.getpixel((curx,y)))/255,2)))
		if power!=newpower or x==im.size[0]-1 :
			if x>1:
				
				
				
				gcode +="G1 X"+str(round(float(curx-(1*direction))/dpi*25.4,3))+" S"+str(power)+" F"+str(speed)+"\n"
				gcodelines+=1
			power=newpower
			
	direction=-direction
	

gcode += "M11\n"
gcode +="G0 XO Y0 Z0\n"

#print gcode
print "le gcode a "+ str(gcodelines) + " lignes"


#witting file
gcodefile = open(name[0]+".gcode", 'w')
gcodefile.write(gcode)
gcodefile.close()
	
